<?php

/**
 * Description of Cast
 *
 * @author Andres
 */
abstract class Cast {

    static function getInstantiatedEntityFromJsonObject(&$entity, &$resultset) {
        $_ret = &$entity;
        
        foreach ($resultset as $key => $value) {
            $_methodSet = "set" . ucfirst($key);
            if (method_exists($_ret, $_methodSet)) {
                $_value = $resultset->$key;
                
                //if($_value == null){ Lo cambié a === porque los boolean FALSE caian en el if
                if($_value === null){
                    $_ret->$_methodSet($_value);
                } else if ($entity->getFieldType($key) === "datetime") {
                    $_ret->$_methodSet(DateConversion::ViewFormatToDatetime($_value));
                } else if ($entity->getFieldType($key) === "date") {
                    $_ret->$_methodSet(DateConversion::ViewFormatToDate($_value));
                } else if (is_object($_value)) {                   
                    if ($_value->id || $_value->value){
                        if($_value->id)
                            $_ret->$_methodSet($_value->id);
                        else
                            $_ret->$_methodSet($_value->value);
                    }else
                        $_ret->$_methodSet($_value);
                } else if (gettype($_value) === 'boolean') {
                    if ($_value)
                        $_value = true;
                    else
                        $_value = false;
                    $_ret->$_methodSet($_value);
                }else {
                    $_ret->$_methodSet($_value);
                }
            }
        }
        return $_ret;
    }

    static function entityToArray($entity) { 
        
        
        $_ret = array();
        $reflectionClass = new ReflectionClass($entity);
        $properties = $reflectionClass->getProperties(ReflectionProperty::IS_PUBLIC | ReflectionProperty::IS_PROTECTED | ReflectionProperty::IS_PRIVATE);
        foreach ($properties as $property) {               
            $_methodGet = "get" . ucfirst($property->name);
                        
            if(method_exists($entity, $_methodGet) && ($property->class !== "DAO")){
                $value = $entity->$_methodGet();
                $_xvalue = $value;
                                
                if (is_object($value)) {
                                
                    if ($value instanceof DateTime) { 
                        $class = $property->class;                        
                        if ($entity->getFieldType($property->name) === "datetime") {
                            $_xvalue = DateConversion::DateTimeToViewFormat($value);
                        } else{
                            $_xvalue = DateConversion::DateToViewFormat($value);
                        }
                    } else {       
                                                
                        if (method_exists($value, "toArray")) {
                            $_xvalue = $value->toArray($value);
                        }
                    }
                } else if($entity->getFieldType($property->name) === 'boolean'){
                    
                    if($value === '1' || $value === 1)
                        $_xvalue = (bool) true;    
                    else
                        $_xvalue = (bool) false;
                }
                $_ret[$property->name] = $_xvalue;
            }
                
        }
        
        return $_ret;
    }

}
