<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

require_once 'daoResponse.php';

/**
 * Description of daoSql
 *
 * @author pc3
 */
class daoSql {

    
    private $dbConnect;

    function __construct($dbConnect = false) {
        if ($dbConnect)
            $this->dbConnect = $dbConnect;
    }

    /**
     * @param string $query
     * @return daoResponse
     */
    function select($query) {
        $cursor = $this->dbConnect->Query($query);
        $ret = new daoResponse($cursor);
        return $ret;
    }

    /**
     * Se utiliza para Inset y Update.
     * 
     * @param string $query
     * @return daoResponse
     */
    function exec($query) {
        $result = $this->dbConnect->exec($query);
        $ret = new daoResponse($result);
        return $ret;
    }


    /**
     * Setea un limite de filas que trae la consulta.
     *
     * @param $length
     * @param $start
     */
    function setLimit($length, $start){
        $this->dbConnect->setLimit($length, $start);
    }


    function dbConnect() {
        $dao = new Dao2();
        $this->dbConnect = $dao->dbConnect();
        return $this->dbConnect;
    }
    function getDbConnect() {
        return $this->dbConnect;
    }

    function setDbConnect($dbConnect) {
        $this->dbConnect = $dbConnect;
    }

    function getLastInsertID($tableName){
        return $this->dbConnect->lastInsertID($tableName);
    }

}
